package Vyroba_evidence_jinezmeny;

my $pkg="Vyroba_evidence_jinezmeny";

# !!!!!!!!!!!
# !!!! POZOR funkce zde jsou volany take z odpracvyk.phtml pak: get_env("progtyp") "odpracvyk" nebo "odpracvykvyrprikazy"
#            - tedy ne jenom z funkce jinezmeny.phtml
# !!!!!!!!!!!

use strict;
use My;
use Kusovnik_norm;
use Info;
use Conversion;

#==== Globalni promena tohohle balicku
my $dbh=My->dbh;


#- vraci zaznam z tabulky JineZmenyvyr
sub info_jinezmeny {
   my ($pkg_p, $ucetobd,$kmstrvys,$zak,$oper,$porc)=@_;
   my $sth_jinezmeny=$dbh->prepare(q{
      select
        JineZmenyvyr.*
      from
        Vyroba_evidence.JineZmenyvyr
      where
        JineZmenyvyr.org=? and
        JineZmenyvyr.ucetobd=? and
        JineZmenyvyr.kmstrvys=? and
        JineZmenyvyr.zak=? and
        JineZmenyvyr.oper=? and
        JineZmenyvyr.porc=?
   });
   $sth_jinezmeny->execute(get_env("org"),$ucetobd,$kmstrvys,$zak,$oper,$porc);
   my $ref_jinezmeny=$sth_jinezmeny->fetchrow_hashref;
   $sth_jinezmeny->finish;
   return $ref_jinezmeny;
}

#- kontrola spravnosti syntaxe hlaseni
sub check_hlaseni {
   my ($pkg_p, $hlaseni)=@_;
   if($hlaseni!~/^\d{5}$/) {
      $hlaseni=undef;
   }
   return $hlaseni;
}

#- fce vraci stredisko z normativu, kde bude menen stav pri zmetkovani
#  !!! stav je menen na kmstr presne dle normativu na zaklade, tedy zavisi jen na zak a kmint
#  !!! pokud vsak neni normativ nalezen je vraceno stredisko vyskytu a zde se pak predpoklada zmena stavu
sub kmstrvys {
   my ($pkg_p, $zak,$kmint,$strvys)=@_;
   my $kmstrvys;
   my $info_normativy=Info->normativy($zak,$kmint);
   if(!length($$info_normativy{kmstr})) {
      $kmstrvys=$strvys;
   }
   else {
      $kmstrvys=$$info_normativy{kmstr};
   }
   return $kmstrvys;
}

#- aktualizace Prijem, Stav, Vydejky
sub update {
   my ($pkg_p,$polozky)=@_;
   # nastaveni nekterych automatickych nebo vypoctenych hodnot
   my $kszm=Conversion->ksznam($$polozky{kszm}{value},$$polozky{znam}{value});
   my $uhrada=Conversion->ksznam($$polozky{uhrada}{value},$$polozky{znam}{value});
   # ZAPIS
   my $datvys;
   # Pokud, jde o zmetkovani vazane na odpracovany vykon, tak jiz nic nerozpadam a zapisuji jen do JineZmenyvyr (tedy nezapisuji, jiz do stavu, vyrprikazu,...) - vse bylo jiz totiz zapsano pri Odvadeni odpr. vykonu
   if(get_env("progtyp") eq "zmetkyodprvyk") {
      # informace z JineZmenyvyr
      my $ref_jinezmeny=$pkg->info_jinezmeny("0000-00",$$polozky{kmstrvys}{value},$$polozky{zak}{value},$$polozky{oper}{value},$$polozky{porc}{value});
      $datvys=$$ref_jinezmeny{datvys};
      # smazani puvodniho zaznamu v JineZmenyvyr - zapsaneho pri Odvadeni odpracovaneho vykonu
      my $sth_del=$dbh->prepare(q{
         delete from
            Vyroba_evidence.JineZmenyvyr
         where
            JineZmenyvyr.org=? and
            JineZmenyvyr.ucetobd=? and
            JineZmenyvyr.kmstrvys=? and
            JineZmenyvyr.zak=? and
            JineZmenyvyr.oper=? and
            JineZmenyvyr.porc=?
      });
      $sth_del->execute(get_env("org"),"0000-00",$$polozky{kmstrvys}{value},$$polozky{zak}{value},$$polozky{oper}{value},$$polozky{porc}{value});
   }
   # Pokud nejde o zmetkovani vazane na odpracovany vykon, je treba rozpadat a menit stav a nekdy i zapisovat do vyrobnich prikazu apod... jednotlivych elementu
   else {
      $datvys=My->date_now;
      # zapis odvadeni pro pripadne elementy
      set_env("odvadeni_elementy",0); # zapis cisla 0 do pomocne globalni promene prostredi, ktera pokud dojde k zapisu elementu bude zmenena na hodnotu 1 (fci Vyroba_evidence->write_jinezmeny_elementy)
      # nebudu rozpadat pokud jde o hv a rv
      if(get_env("vyrtyp") ne "sklhs" and get_env("vyrtyp") ne "sklrv") {
         # Kdyz nejde o manka zapisuji i do vyrobnich prikazu (Vyroba_evidence->write_odvadeni_pruchod)
         if(get_env("progtyp") ne "manka" and get_env("progtyp") ne "specjzm") {
            Kusovnik_norm->kusovnik_str(
               Kusovnik->ini({
                  zak =>         $$polozky{zak}{value},
                  mnoz =>        $kszm,
                  hlaseni =>     $$polozky{hlaseni}{value},
                  znzm =>        $$polozky{znzm}{value},
                  priczm =>      $$polozky{priczm}{value},
                  strvys =>      $$polozky{strvys}{value},
                  strvin =>      $$polozky{strvin}{value},
                  oc =>          $$polozky{oc}{value},
                  uhrada =>      "0", ## ZMENA 2003-03-06 - u elementu nyni uhradu nezapisuji, zapise se jen na celek
                  datvys =>      $datvys,
                  pozn =>        $$polozky{pozn}{value},
                  _funkce =>     "Kusovnik_norm->kusovnik_str",
                  _funkce_str => "Vyroba_evidence->write_jinezmeny_elementy",
                  _funkce_str_pruchod => "Vyroba_evidence->write_odvadeni_pruchod",
                  _str =>        $$polozky{kmstrvys}{value},
                  _odkmint =>    $$polozky{kmint}{value},
                  _indmax =>     1
               })
            );
         }
         # Kdyz jde o manka nezapisuji do vyrobnich prikazu (schazi - Vyroba_evidence->write_odvadeni_pruchod)
         else {
            Kusovnik_norm->kusovnik_str(
               Kusovnik->ini({
                  zak =>         $$polozky{zak}{value},
                  mnoz =>        $kszm,
                  hlaseni =>     $$polozky{hlaseni}{value},
                  znzm =>        $$polozky{znzm}{value},
                  priczm =>      $$polozky{priczm}{value},
                  strvys =>      $$polozky{strvys}{value},
                  strvin =>      $$polozky{strvin}{value},
                  oc =>          $$polozky{oc}{value},
                  uhrada =>      "0", ## ZMENA 2003-03-06 - u elementu nyni uhradu nezapisuji, zapise se jen na celek
                  datvys =>      $datvys,
                  pozn =>        $$polozky{pozn}{value},
                  _funkce =>     "Kusovnik_norm->kusovnik_str",
                  _funkce_str => "Vyroba_evidence->write_jinezmeny_elementy",
                  _str =>        $$polozky{kmstrvys}{value},
                  _odkmint =>    $$polozky{kmint}{value},
                  _indmax =>     1
               })
            );
         }
      }
   }
   # zapis JineZmenyvyr pro celek - je jiny pokud jsem prochazel kusovnikem, respektive pokud jde o zmetkovani vazane na Odpracovany vykon (pak totiz nemenim stav celku a nezapisuji do vyrobnich prikazu celku - udelal jsem to totiz jiz pri rozpadu u elementu, respektive to bylo udelano pri Odvadeni odprac. vykonu)
   #                             -> stav celku a vyr.prikazy celku menim jen pokud jsem nerozpadal a nebo nejde o zmetkovani vazane na odpracovany vykon
   Vyroba_evidence->write_jinezmeny_celek(
      {
         kmstrvys =>    $$polozky{kmstrvys}{value},
         zak =>         $$polozky{zak}{value},
         oper =>        $$polozky{oper}{value},
         hlaseni =>     $$polozky{hlaseni}{value},
         kmint =>       $$polozky{kmint}{value},
         prik =>        $$polozky{prik}{value},
         kszm =>        $kszm,
         znzm =>        $$polozky{znzm}{value},
         priczm =>      $$polozky{priczm}{value},
         strvys =>      $$polozky{strvys}{value},
         strvin =>      $$polozky{strvin}{value},
         oc =>          $$polozky{oc}{value},
         uhrada =>      $uhrada,
         datvys =>      $datvys,
         pozn =>        $$polozky{pozn}{value},
         _odvadeni_elementy => get_env("odvadeni_elementy")
      }
   );
}

