package Vyroba_planovani_objednavky;

my $pkg="Vyroba_planovani_objednavky";

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;

#==== Globalni promena tohohle balicku

#==== Napojeni na DB
my $dbh=My->dbh;

#======================================
sub poslobdobivyp {
   my $sth=$dbh->prepare(q{
      select
         Objednavky_navrh.obdobivyp
      from
         Vyroba_planovani.Objednavky_navrh
      where
         Objednavky_navrh.org=?
      order by
         Objednavky_navrh.obdobivyp desc
      limit
         1
   });
   $sth->execute(get_env("org"));
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   return $$ref{obdobivyp};
}

# Oznaceni pripadneho aktualniho navrhu objednavek jako jiz neaktualniho - nebude jiz mozna aktualizace
sub oznac_za_neaktnavrh_zakaznikico { # tahle je spise doplnkova a pro jistotu, ta na org by mela vse resit jiz predtim...
   my ($pkg_p, $zakaznikico)=@_;
   my $sth=$dbh->prepare(q{
      update
         Vyroba_planovani.Objednavky_navrh
      set
         Objednavky_navrh.znmv=?
      where
         Objednavky_navrh.zakaznikico=?
   });
   $sth->execute("1", $zakaznikico);
}
sub oznac_za_neaktnavrh_org {
   my ($pkg_p, $org)=@_;
   my $sth=$dbh->prepare(q{
      update
         Vyroba_planovani.Objednavky_navrh
      set
         Objednavky_navrh.znmv=?
      where
         Objednavky_navrh.org=?
   });
   $sth->execute("1", $org);
}

# zruseni znaku urgence u objednavek
sub zrus_znak_urgence {
   my ($pkg_p, $org)=@_;
   my $sth=$dbh->prepare(q{
      update
         Vyroba_planovani.Objednavky
      set
         Objednavky.pozn=substring(Objednavky.pozn,2)
      where
         Objednavky.org=? and
         Objednavky.pozn like "!%"
   });
   $sth->execute($org);
}

# zruseni znaku urgence u navrhu objednavek
sub zrus_znak_urgence_u_navrhu {
   my ($pkg_p, $org)=@_;
   my $sth=$dbh->prepare(q{
      update
         Vyroba_planovani.Objednavky_navrh
      set
         Objednavky_navrh.pozn=substring(Objednavky_navrh.pozn,2)
      where
         Objednavky_navrh.org=? and
         Objednavky_navrh.pozn like "!%"
   });
   $sth->execute($org);
}

return 1;

