package Maccess_locale;

my $pkg="Maccess_locale";

use Exporter ();
@ISA=qw(Exporter);
@EXPORT=qw(translate);

use strict;
use lib ("/home/web-mycompany/www/maccess/bin","/home/web-mycompany/www/lib");

use My;
use MyCGI;
use Maccess_db;

my $dbh_sys=Maccess_db->dbh_sys;

#- nataveni globalni promene "lang" na nastaveny jazyk v Maccessu (vyuzito pak napriklad u formatovani cisel)
set_env("lang",$pkg->language);

#- funkce vraci nastaveny jazyk
sub language {
   my $language;
   my %language_supported=$pkg->language_supported;
   my $query=MyCGI->cgisession;
   # CGI
   if(defined($query->param("language"))) {
      $language=$query->param("language");
   }
   # Cookie
   elsif(defined($query->cookie(-name=>"language"))) {
      $language=$query->cookie(-name=>"language");
   }
   # HTTP_ACCEPT_LANGUAGE - zvoleni jazyka dle nasraveni prohlizece
   elsif(length($ENV{HTTP_ACCEPT_LANGUAGE})) {
      foreach my $acclangs (split(/,/,$ENV{HTTP_ACCEPT_LANGUAGE})) {
         my ($acclang,$accq)=split(/;/,$acclangs);
         if(defined($language_supported{$acclang})) {
            $language=$acclang;
            last;
         }
      }
   }
   # Prednastaveny jazyk
   if(!defined($language)) {
      $language="en";
   }
   return $language;
}

#- funkce vraci seznam jazyku podporovanych Maccessem
sub language_supported { return ( "cs" => "Czech", "en" => "English" ); }

#- funkce vraci nastavenou znakovou sadu
sub charset {
   my $charset;
   my $query=MyCGI->cgisession;
   if(defined($query->param("charset"))) {
      $charset=$query->param("charset");
   }
   elsif(defined($query->cookie(-name=>"charset"))) {
      $charset=$query->cookie(-name=>"charset");
   }
   else {
      # Prednastavena znakova sada
      if($pkg->language eq "cs") {
         $charset="windows-1250";
      }
      else {
         $charset="iso-8859-1";
      }
   }
   return $charset;
}

#- funkce vraci seznam jazyku podporovanych Maccessem
sub charset_supported { return ( "iso-8859-1" => "iso-8859-1", "iso-8859-2" => "iso-8859-2", "windows-1250" => "windows-1250" ); }

#- funkce zajistujici konverzi jmen znakovych sad pro knihovnu Unicode::Map8
sub charset_pkgUnicode { return ( "UTF-8" => "UTF-8", "iso-8859-1" => "ISO_8859-1", "iso-8859-2" => "ISO_8859-2", "windows-1250" => "cp1250" ); }

#- funkce zajistujici preklad hlasek Maccessu na nastaveny jazyk
sub translate {
   my ($text_for_translation,@values)=@_;
   my $translation;
   if($pkg->language ne "en") {
      my $sth=$dbh_sys->prepare(q{
         select
            Language.translation
         from
            Language
         where
            Language.text_for_translation=? and
            Language.lang=?
      });
      $sth->execute($text_for_translation,$pkg->language);
      if($sth->rows) {
         my $ref=$sth->fetchrow_hashref;
         $translation=$$ref{translation};
      }
      else {
         $translation=$text_for_translation;
      }
      $sth->finish;
   }
   else {
      $translation=$text_for_translation;
   }
   # doplneni @values do $translation na mista :0, :1, ...
   my $translation_and_values;
   foreach my $translation_substr (split(/(:\d)/,$translation)) {
      if($translation_substr=~/^:(\d)$/) {
         $translation_and_values.=$values[$1];
      }
      else {
         $translation_and_values.=$translation_substr;
      }
   }
   return $translation_and_values;
}

return 1;
